/***************************************************************
 CPU UART VAR\[o̓hCo(SH7262/7264 SCIFp)
***************************************************************/

/* CPU UARTo̓wb_ */
#include "cpu_uart.h"

/* UARTRg[ */

#define	USE_BPS		38400	/* ʐMx 19200 or 38400 */

#define	USE_UART_CH		0	/* UART`l2 or 3 */


#if (USE_BPS == 38400)
	#define SCBRR_SET 19
#endif
#if (USE_BPS == 19200)
	#define SCBRR_SET 38
#endif

#if (USE_UART_CH == 0)
	/* FIFOtVARg[SCIF(SCIF0) */
	#define BaseAddr (0xFFFE8000)
#endif
#if (USE_UART_CH == 2)
	/* FIFOtVARg[SCIF(SCIF2) */
	#define BaseAddr (0xFFFE9000)
#endif
#if (USE_UART_CH == 3)
	/* FIFOtVARg[SCIF(SCIF3) */
	#define BaseAddr (0xFFFE9800)
#endif

/* FIFOtVARg[SCIF(SCIFx) */
#define SCSMR	((volatile unsigned short int *)(BaseAddr+0x000))
#define SCBRR	((volatile unsigned char      *)(BaseAddr+0x004))
#define SCSCR	((volatile unsigned short int *)(BaseAddr+0x008))
#define SCFTDR	((volatile unsigned char      *)(BaseAddr+0x00C))
#define SCFSR	((volatile unsigned short int *)(BaseAddr+0x010))
#define SCFRDR	((volatile unsigned char      *)(BaseAddr+0x014))
#define SCFCR	((volatile unsigned short int *)(BaseAddr+0x018))
#define SCFDR	((volatile unsigned short int *)(BaseAddr+0x01C))
#define SCSPTR	((volatile unsigned short int *)(BaseAddr+0x020))
#define SCLSR	((volatile unsigned short int *)(BaseAddr+0x024))

/* |[gRg[䃌WX^ */
#define PFCR1	((volatile unsigned short int *)(0xFFFE38AC))
#define PFCR0	((volatile unsigned short int *)(0xFFFE38AE))
#define PJCR0	((volatile unsigned short int *)(0xFFFE390E))

/* W[X^oCRg[䃌WX^ */
#define STBCR4	((volatile unsigned char *)(0xFFFE040C))


/* R\[(UART) */
void CPU_UartInitialize(void)
{
	unsigned short int sts;
#if (USE_UART_CH == 0)
	/* |[gݒ(RXD0(PJ1),TXD0(PJ0)) */
	*PJCR0 = (*PFCR0&0xFF00)|0x0044;
	/* SCIF0X^oC */
	*STBCR4 = (*STBCR4 & 0x7F);	/* SCIF0 */
#endif
#if (USE_UART_CH == 2)
	/* |[gݒ(RXD2(PF2),TXD2(PF1))(CQBB P2RlN^) */
	*PFCR0 = (*PFCR0&0xF00F)|0x0440;
	/* SCIF2X^oC */
	*STBCR4 = (*STBCR4 & 0xDF);	/* SCIF2 */
#endif
#if (USE_UART_CH == 3)
	/* |[gݒ(RXD3(PF3))(CQBB P1RlN^)*/
	*PFCR0 = (*PFCR0&0x0FFF)|0x4000;
	/* |[gݒ(TXD3(PF4))(CQBB P1RlN^)*/
	*PFCR1 = (*PFCR1&0xFFF0)|0x0004;
	/* SCIF3X^oC */
	*STBCR4 = (*STBCR4 & 0xEF);	/* SCIF3 */
#endif
	/* SCIFxݒ */
	*SCSCR = 0x0000;	/* TE=0,RE=0,CKE1=0 */
	*SCFCR = 0x0006;	/* TFRST=1,RFRST=1 */
	sts    = *SCFSR;	/* MXe[^Xǂ */
	*SCFSR = 0x0000;	/* MXe[^XNA */
	*SCSMR = 0x0000;	/* CHR=0,PE=0,STOP=0,CKS=00(P/1) */
	*SCBRR = SCBRR_SET;	/* ݒ */
	*SCFCR = 0x0000;	/* TREG:8bytes RTRG:1bytes */
	*SCSCR = 0x0030;	/* TIE=0,RIE=0,TE=1,RE=1, RIE=0 */
}

/* R\[1o */
void CPU_UartPutch(unsigned char data)
{
	while(1){
		if (*SCFSR & 0x0020 ) {	/* Mobt@󂢂Ă邩 */
			*SCFTDR = data;		/* Mf[^ */
			*SCFSR  = *SCFSR & 0xFFDF;	/* MtONA */
			break;
		}
	}
}

/* R\[o(\n CR+LFo) */
void CPU_UartPuts(unsigned char *buffer)
{
	unsigned char data;
	while( (data = *(buffer++)) != 0){	/* null܂ŏo */
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[o(񒷂wt/\n CR+LFo) */
void CPU_UartPutsL(unsigned char *buffer, int len)
{
	int i;
	unsigned char data;
	for(i=0;i<len;i++){
		data=*(buffer++);
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
	unsigned short int sts;
	if (*SCLSR & 1) {	/* MI[oG[ԊmF */
		*SCLSR = 0; /* MI[oG[NA */
	}
	sts = *SCFSR;	/* MXe[^X擾 */
	if (sts & 0x0009C ) {	/* MG[/u[N/t[~OG[/peBG[ԊmF */
		*SCFSR = 3;	/* eG[NA */
		/* G[f[^̋ǂ݂͂ĂȂ̂ŁA*/
		/* ̌ŃG[f[^̂܂܎M */
	}
	if (sts & 0x0002 ) {/* f[^M */
		return 1;	/* Mf[^ */
	} else {
		return 0;	/* Mf[^Ȃ */
	}
}

/* R\[1(GR[obNȂ) */
unsigned char CPU_UartGetch(void)
{
	unsigned char data;
	while(1){
		if (CPU_UartRecvCheck()) {	/* f[^M */
			data = *SCFRDR;		/* Mf[^ǂݏo */
			*SCFSR = *SCFSR & 0xFFFC;	/* MtONA */
			break;
		}
	}
	return data;
}

/* R\[(CRR[h܂/ő255/GR[obN) */
int CPU_UartGets(unsigned char *buffer)
{
	unsigned char data;
	int i;
	i=0;
	while(1){
		data = CPU_UartGetch();	/* 1 */
		*buffer = data;
		CPU_UartPutch(data);	/* 1o(GR[obN) */
		buffer++;
		i++;
		if (i > 255) break;		/* ő啶ɒB */
		if (data == 0x0D) break;/* CRR[h܂ŎM */
	}
	*buffer=(unsigned char)0;	/* nullR[h */
	return i;					/* ͕ */
}

